﻿Imports System
Imports System.Configuration
Imports System.Collections
Imports System.Data
Imports System.Globalization
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls

Imports Telerik.Web.UI


Partial Public Class AdvancedFormVB
    Inherits System.Web.UI.Page
    Private Enum WindowMode
        Edit
        Insert
    End Enum

    Private mode As WindowMode

    Protected Sub DefaultVB_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init
        RadScheduler1.Provider = New XmlSchedulerProvider(Server.MapPath("~/App_Data/Appointments.xml"), True)
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        mode = DirectCast([Enum].Parse(GetType(WindowMode), Request("Mode")), WindowMode)
      
    End Sub

    Private Sub PopulateEditForm()
        Dim aptStart As DateTime
        Dim aptEnd As DateTime

        If mode = WindowMode.Edit Then
            StatusLabel.Text = "Editing appointment:"
            SubmitButton.Text = "Update"

            Dim apt As Appointment = GetEditedAppointment()
            DescriptionText.Text = apt.Subject
            aptStart = RadScheduler1.UtcToDisplay(apt.Start)
            aptEnd = RadScheduler1.UtcToDisplay(apt.[End])
        Else
            StatusLabel.Text = "New appointment:"
            SubmitButton.Text = "Insert"

            aptStart = ParseJavaScriptTime(Request("Start"))
            If Boolean.Parse(Request("IsAllDay")) = True Then
                aptStart = RadScheduler1.UtcToDisplay(RadScheduler1.UtcDayStart(aptStart))
                aptEnd = aptStart.AddDays(1)
            Else
                aptEnd = aptStart.AddHours(1)
            End If
        End If

        StartTime.SelectedDate = aptStart
        EndTime.SelectedDate = aptEnd
    End Sub

    Private Function ParseJavaScriptTime(ByVal jsTime As String) As DateTime
        Dim result As DateTime = DateTime.ParseExact(jsTime, "yyyyMMddHHmm", Nothing, DateTimeStyles.AssumeUniversal)
        Return result.ToUniversalTime
    End Function

    Private Function GetEditedAppointment() As Appointment
        Dim aptId As Integer

        If Integer.TryParse(Request("AppointmentId"), aptId) Then
            Return RadScheduler1.Appointments.FindByID(aptId)
        Else
            Throw New Exception("Cannot find appointment with ID = " + Request("AppointmentId"))
        End If
    End Function

    Protected Sub SubmitButton_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim aptStart As DateTime = RadScheduler1.DisplayToUtc(StartTime.SelectedDate.Value)
        Dim aptEnd As DateTime = RadScheduler1.DisplayToUtc(EndTime.SelectedDate.Value)

        If mode = WindowMode.Edit Then
            Dim apt As Appointment = GetEditedAppointment()
            apt.Subject = DescriptionText.Text
            apt.Start = aptStart
            apt.[End] = aptEnd

            RadScheduler1.UpdateAppointment(apt)
        Else
            ' Insert
            Dim apt As New Appointment()
            apt.Start = aptStart
            apt.[End] = aptEnd
            apt.Subject = DescriptionText.Text

            RadScheduler1.InsertAppointment(apt)
        End If

        ScriptPlaceholder.Text = "GetRadWindow().Close();"
    End Sub

    Protected Sub RadScheduler1_DataBound(sender As Object, e As System.EventArgs) Handles RadScheduler1.DataBound
        PopulateEditForm()
    End Sub
End Class

